
(define (test-runtime)
  (%print "gc:") (%print (%gc))
  (%print "(eq? #\\A (integer->char 65))") (%print (%eq? #\A (integer->char 65)))
  (%print "#\\A =>") (%print #\A)
  (%print "(integer->char 65)") (%print (integer->char 65))
  (%print "-8 ==") (%print -8)
  (%print "room:") (%print (%room))
  (%print (string-ref "sam" 1))
  (%print (map (lambda (x) (%* x x)) '(1 2 3 4 5)))
  (%print (number->string 3141))
  (%print "gc:") (%print (%gc))

  (let ((s "funky"))
	(%print s)
	(%string-set! s 0 #\m)
	(%print s)
	(%print (apply string-set! (list s 0 #\j)))
	(%print s)
	)

  (%print "assoc-string test")
  (%print (assoc-string "abc" symbol-table))
  (%print "string->symbol test")
  (%print (%eq? 'abc (string->symbol (list->string '(#\a #\b #\c)))))
  (%print symbol-table)

  (%print "gc:") (%print (%gc))

  (let loop ((n 5))
    (%print n)
    (let tak ((x 18) (y 12) (z 6))
      (if (%ge? y x)
  		z
  		(tak (tak (%- x 1) y z)
  			 (tak (%- y 1) z x)
  			 (tak (%- z 1) x y))))
    (if (%eq? n 0)
        99
        (loop (%- n 1))))
  
  (%print ((lambda (x) (+ x 1)) 5))
  (%print "gc:") (%print (%gc))
  (%print "trying to dump an image...")
  (%dump-image (lambda () (%print "hi there from the other side")))
  (%print "done!")
  )

;;;(initialize-runtime)
