;; tak20.ljc
(let loop ((n 20))
  (%print n)
  (let tak ((x 18) (y 12) (z 6))
    (if (%ge? y x)
	z
	(tak (tak (%- x 1) y z)
	     (tak (%- y 1) z x)
	     (tak (%- z 1) x y))))
  (if (%eq? n 0)
      99
      (loop (%- n 1)))))

;; list loop

(let loop ((n 0)
	   (l ()))
  (if (%eq? n 100)
      l
      (loop (%+ n 1) (%cons n l)))))
       
;; call/cc

(let ((saved #f))
  (let loop ((n 10))
    (%print n)
    (if (%eq? n 5)
	(set! saved (%getcc)))
    (if (%eq? n 0)
	99
	(loop (%- n 1))))
  (saved)
  (saved)))
      
;; recursive function definition
(define (fact n)
  (define (ifact n a)
    (if (%eq? n 0)
	a
	(ifact (%- n 1) (%* n a))))
  (ifact n 1))

(define (nqueens n)

  (define (one-to n)
    (let loop ((i n) (l '()))
      (if (= i 0) l (loop (- i 1) (cons i l)))))

  (define (try x y z)
    (if (null? x)
      (if (null? y) 1 0)
      (+ (if (ok? (car x) 1 z)
           (try (append (cdr x) y) '() (cons (car x) z))
           0)
         (try (cdr x) (cons (car x) y) z))))

  (define (ok? row dist placed)
    (if (null? placed)
      #t
      (and (not (= (car placed) (+ row dist)))
           (not (= (car placed) (- row dist)))
           (ok? row (+ dist 1) (cdr placed)))))

  (try (one-to n) '() '()))
